{************************************************************************}
{*  (c) 1995-99 by Richard Fellner, A-1020 Vienna. All Rights Reserved. *}
{*----------------------------------------------------------------------*}
{*  Internet: http://i.am/Fellner                                       *}
{*  email   : r.fellner@bigfoot.com                                     *}
{*----------------------------------------------------------------------*}
{*  This code may not be copied or distributed in any format electronic *}
{*  or otherwise except one copy for backup purposes.                   *}
{*  No Delphi Component Kit or Component individually or in a           *}
{*  collection subclassed or otherwise from the code in this unit,      *}
{*  or associated .pas, .dfm, .dcu, .asm or .obj files may be sold      *}
{*  or distributed without express permission of the author.            *}
{*  For more licence informations please refer to the associated        *}
{*  Help/ReadMe file or get into contact with the author.               *}
{*----------------------------------------------------------------------*}
{*  $Date: 17.03.1999 - 01:48:56 $                                      *}
{************************************************************************}
unit Unit1;
interface
uses
  Windows, Messages, Forms,
  Buttons, StdCtrls, ExtCtrls, SysUtils, Dialogs,
  Graphics, Controls, Classes,
  FileCtrl, ShellAPI;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    edMsgDir: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edMBXName: TEdit;
    sbtStart: TSpeedButton;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label6: TLabel;
    sbtSelDir: TSpeedButton;
    Bevel2: TBevel;
    Image1: TImage;
    Label7: TLabel;
    Image2: TImage;
    Label8: TLabel;
    Label9: TLabel;
    Bevel3: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure sbtStartClick(Sender: TObject);
    procedure sbtSelDirClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function CHARONE(ch:CHAR; Strg:String): String;

var
  Form1: TForm1;

implementation
{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
VAR
   s: String;
begin
   GetDir(0,s);
   edMsgDir.Text := s;
   edMBXName.Text := CharOne('\',s+'\Test.MBX');
end;

procedure TForm1.sbtStartClick(Sender: TObject);
var
  s: String;
  sr,sr1: TSearchRec;
  Txt: TextFile;
  Bin: File;
  Result: Integer;
  Files: Longint;
begin
  Files := 0;
  AssignFile(Bin,edMBXName.Text);
  Rewrite(Bin,1);
  IF FindFirst(Charone('\',edMsgDir.Text+'\*.Msg'), faArchive, sr)=0 THEN
  REPEAT
     sr1 := sr;
     INC(Files);
     Label6.Caption := 'Exporting '+sr.Name; Label6.Update;
     AssignFile(Txt,CharOne('\',edMsgDir.Text+'\'+sr.Name));
     Reset(Txt);
     WHILE not EOF(Txt) DO BEGIN
        ReadLn(Txt,s);
        IF COPY(s,1,24)='-------Phoenix-Boundary-' THEN // Phoenix "end of msg" ID
           Break
        ELSE BEGIN
           s := s+#13#10;
           BlockWrite(Bin,s[1],Length(s),Result);
           IF Result<>LENGTH(s) THEN BEGIN
              MessageDlg('Write error',mtError,[mbok],0);
              Break;
           END;
        END;
     END;
     CloseFile(Txt);
     sr := sr1;
  UNTIL FindNext(sr)<>0;
  FindClose(sr);
  CloseFile(Bin);
  MessageBeep(0);
  MessageDlg(IntToStr(Files)+' files converted to '+edMBXName.Text+'!',mtInformation,[mbok],0);
end;

{*-------------------------------------------------------------------*}
  function CHARONE(ch:CHAR; Strg:String): String;
{*-------------------------------------------------------------------*}
VAR
   l,x,
   Counter: Integer;
   OldCh : CHAR;
BEGIN
   Counter   := 0;
   l         := LENGTH(Strg);
   OldCh     := ch;
   SetLength(Result,l);  // zunchst mal so..
   IF l>1 THEN BEGIN
      FOR x := 1 TO l DO BEGIN
         IF (Strg[x]<>ch) or (Strg[x]<>OldCh)  THEN BEGIN
            INC(Counter);
            Result[Counter] := Strg[x];
          END;
          OldCh := Strg[x];
      END;
      SetLength(Result,Counter);
   END;
END;


procedure TForm1.sbtSelDirClick(Sender: TObject);
VAR
   s: String;
begin
   s := edMsgDir.Text;
   IF SelectDirectory(s,[],0) THEN
      edMsgDir.Text := s;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  IF Sender=Image1 THEN
     ShellExecute(0,nil,'http://Inner-Smile.com',nil,nil,SW_SHOWNORMAL)
  ELSE
     ShellExecute(0,nil,'http://www.pobox.com/~touri/phoenix/',nil,nil,SW_SHOWNORMAL);
end;

end.
